"use strict";

/*
Copyright (c) 2018 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/

/* eslint-env node */

/* eslint-disable flowtype/require-valid-file-annotation */

/* global after */
var scenarios = require('./examples-list');

var _require = require('../../e2e/helpers'),
    goToUrl = _require.goToUrl;

var suite = 'Checkbox Test Suite';
var selectors = {
  radioOne: '[data-name="radioSub1"] label',
  radioTwo: '[data-name="radioSub2"] label',
  radioMain: '[data-name="radioMain"] label input[type="checkbox"]'
};
describe('The checkbox component', function () {
  after(function (browser, done) {
    browser.end(function () {
      return done();
    });
  });
  it('can switch states', function (browser) {
    goToUrl({
      suite: suite,
      test: scenarios.INDETERMINATE,
      browser: browser
    }).initAccessibility().waitForElementVisible(selectors.radioOne).click(selectors.radioOne).click(selectors.radioTwo).assert.accessibility('html', {}).assert.attributeEquals(selectors.radioMain, 'checked', 'true');
  });
});