"use strict";

/*
Copyright (c) 2018 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/

/* eslint-env node */

/* eslint-disable flowtype/require-valid-file-annotation */

/* global after */
var scenarios = require('./examples-list');

var _require = require('../../e2e/helpers'),
    goToUrl = _require.goToUrl;

var suite = 'Card Test Suite';
describe('The card component', function () {
  after(function (browser, done) {
    browser.end(function () {
      return done();
    });
  });
  Object.keys(scenarios).forEach(function (scenario) {
    it("passes basic a11y tests for ".concat(scenario), function (browser) {
      goToUrl({
        suite: suite,
        test: scenarios[scenario],
        browser: browser
      }).initAccessibility().waitForElementVisible('body').assert.accessibility('html', {
        rules: {
          'image-alt': {
            enabled: false
          }
        }
      });
    });
  });
});