"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Title = exports.Thumbnail = exports.Root = exports.HeaderImage = exports.Contents = exports.Body = exports.Action = void 0;

var _index = require("../styles/index");

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Action = (0, _index.styled)('div', function () {
  return {};
});
exports.Action = Action;
var Body = (0, _index.styled)('div', function (_ref) {
  var $theme = _ref.$theme;
  var colors = $theme.colors,
      sizing = $theme.sizing,
      typography = $theme.typography;
  return _objectSpread({
    marginBottom: sizing.scale600,
    color: colors.mono800
  }, typography.font400);
});
exports.Body = Body;
var Contents = (0, _index.styled)('div', function (_ref2) {
  var $theme = _ref2.$theme;
  var sizing = $theme.sizing;
  return {
    margin: sizing.scale800
  };
});
exports.Contents = Contents;
var HeaderImage = (0, _index.styled)('img', function (_ref3) {
  var $theme = _ref3.$theme;
  var borders = $theme.borders;
  return {
    borderTopLeftRadius: borders.radius200,
    borderTopRightRadius: borders.radius200,
    objectFit: 'contain',
    maxWidth: '100%'
  };
});
exports.HeaderImage = HeaderImage;
var Root = (0, _index.styled)('div', function (_ref4) {
  var $theme = _ref4.$theme;
  var borders = $theme.borders,
      lighting = $theme.lighting;
  return _objectSpread({}, borders.border300, {
    boxShadow: lighting.shadow400,
    borderRadius: borders.radius200
  });
});
exports.Root = Root;
var Thumbnail = (0, _index.styled)('img', function (props) {
  var _props$$theme = props.$theme,
      borders = _props$$theme.borders,
      sizing = _props$$theme.sizing;
  return _objectSpread({
    float: 'right',
    height: sizing.scale2400,
    width: sizing.scale2400,
    objectFit: 'cover',
    borderRadius: borders.radius200
  }, borders.border200, {
    margin: "0 0 ".concat(sizing.scale500, " ").concat(sizing.scale500)
  });
});
exports.Thumbnail = Thumbnail;
var Title = (0, _index.styled)('h1', function (_ref5) {
  var $hasThumbnail = _ref5.$hasThumbnail,
      $theme = _ref5.$theme;
  var colors = $theme.colors,
      sizing = $theme.sizing,
      typography = $theme.typography;
  return _objectSpread({}, typography.font600, {
    color: colors.black,
    fontSize: $hasThumbnail ? sizing.scale600 : sizing.scale700,
    fontWeight: 500,
    margin: "0 0 ".concat(sizing.scale300, " 0"),
    padding: 0
  });
});
exports.Title = Title;