"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getSharedProps = getSharedProps;

/*
Copyright (c) 2018 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
function getSharedProps(props, state) {
  var disabled = props.disabled,
      error = props.error,
      adjoined = props.adjoined,
      size = props.size,
      required = props.required;
  var isFocused = state.isFocused;
  return {
    $isFocused: isFocused,
    $disabled: disabled,
    $error: error,
    $adjoined: adjoined,
    $size: size,
    $required: required
  };
}