"use strict";

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _index = require("../index");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
Copyright (c) 2018 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
describe('Tag styled components', function () {
  describe('StyledRoot', function () {
    test.each([[''], ['$disabled'], ['$isFocused'], ['$isActive']])('', function (prop) {
      var props = {};
      props[prop] = true;
      var component = (0, _enzyme.shallow)(_react.default.createElement(_index.StyledRoot, props, _react.default.createElement("div", null)));
      expect(component.instance().getStyles()).toMatchSnapshot('StyledRoot has correct styles when ' + prop);
    });
  });
  describe('StyledAction', function () {
    test.each([['$disabled'], ['']])('', function (prop) {
      var props = {};
      props[prop] = true;
      var component = (0, _enzyme.shallow)(_react.default.createElement(_index.StyledAction, props, _react.default.createElement("div", null)));
      expect(component.instance().getStyles()).toMatchSnapshot('StyledAction has correct styles when ' + prop);
    });
  });
});