"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LightThemeMove = void 0;

var _creator = _interopRequireDefault(require("./creator"));

var _lightThemePrimitives = require("./light-theme-primitives");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var primaryFontFamily = 'UberMoveText, "Open Sans", "Helvetica Neue", Helvetica, sans-serif';
var secondaryFontFamily = 'UberMove, UberMoveText, "Open Sans", "Helvetica Neue", Helvetica, sans-serif';
var LightThemeMove = (0, _creator.default)(_objectSpread({}, _lightThemePrimitives.primitives, {
  primaryFontFamily: primaryFontFamily
}), {
  typography: {
    font200: {
      fontFamily: primaryFontFamily,
      fontSize: '12px',
      fontWeight: 'normal',
      lineHeight: '20px'
    },
    font250: {
      fontFamily: primaryFontFamily,
      fontSize: '12px',
      fontWeight: 'bold',
      lineHeight: '20px'
    },
    font300: {
      fontFamily: primaryFontFamily,
      fontSize: '14px',
      fontWeight: 'normal',
      lineHeight: '20px'
    },
    font350: {
      fontFamily: primaryFontFamily,
      fontSize: '14px',
      fontWeight: 'bold',
      lineHeight: '20px'
    },
    font400: {
      fontFamily: primaryFontFamily,
      fontSize: '16px',
      fontWeight: 'normal',
      lineHeight: '24px'
    },
    font450: {
      fontFamily: primaryFontFamily,
      fontSize: '16px',
      fontWeight: 'bold',
      lineHeight: '24px'
    },
    font500: {
      fontFamily: primaryFontFamily,
      fontSize: '20px',
      fontWeight: 'bold',
      lineHeight: '28px'
    },
    font600: {
      fontFamily: primaryFontFamily,
      fontSize: '24px',
      fontWeight: 'bold',
      lineHeight: '36px'
    },
    font700: {
      fontFamily: primaryFontFamily,
      fontSize: '32px',
      fontWeight: 'bold',
      lineHeight: '48px'
    },
    font800: {
      fontFamily: primaryFontFamily,
      fontSize: '40px',
      fontWeight: 'bold',
      lineHeight: '56px'
    },
    font900: {
      fontFamily: primaryFontFamily,
      fontSize: '52px',
      fontWeight: 'bold',
      lineHeight: '68px'
    },
    font1000: {
      fontFamily: primaryFontFamily,
      fontSize: '72px',
      fontWeight: 'normal',
      lineHeight: '96px'
    },
    font1100: {
      fontFamily: secondaryFontFamily,
      fontSize: '96px',
      fontWeight: 'normal',
      lineHeight: '116px'
    }
  }
});
exports.LightThemeMove = LightThemeMove;