"use strict";

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _index = require("../index");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

describe('Stateless Select Dropdown', function () {
  var wrapper,
      events = {};
  var allProps = {},
      mockFn;
  var options = [{
    id: '1',
    label: 'label for 1'
  }, {
    id: '2',
    label: 'label for 2'
  }, {
    id: '3',
    label: 'label for 3'
  }, {
    id: '4',
    label: 'label for 4'
  }],
      getOptionLabel = jest.fn(function () {
    return _react.default.createElement("div", null, "test label");
  }),
      isDropDownOpen = true,
      selectedOptions,
      onChange,
      type,
      rows;
  beforeEach(function () {
    mockFn = jest.fn();
    events = {
      onChange: mockFn
    };
    allProps = _objectSpread({}, events, {
      options: options,
      getOptionLabel: getOptionLabel,
      isDropDownOpen: isDropDownOpen,
      selectedOptions: selectedOptions,
      onChange: onChange,
      type: type,
      rows: rows
    });
  });
  afterEach(function () {
    jest.restoreAllMocks();
    wrapper && wrapper.unmount();
  });
  test.each([[options, true], [[], true], [options, false]])('should render component with options %s and drondown open is %s', function (options, isDropDownOpen) {
    allProps = Object.assign({}, allProps, {
      options: options,
      isDropDownOpen: isDropDownOpen
    });
    wrapper = (0, _enzyme.shallow)(_react.default.createElement(_index.StyledDropDown, allProps));
    expect(wrapper).toMatchSnapshot('Component has correct render with options length ' + options.length + ' and dropdown open is %s ' + isDropDownOpen);
  });
});