"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = SelectDropDown;

var React = _interopRequireWildcard(require("react"));

var _styledComponents = require("./styled-components");

var _constants = require("./constants");

var _menu = require("../menu");

var _spinner = require("../spinner");

var _overrides = require("../helpers/overrides");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function SelectDropDown(props) {
  var _props$overrides = props.overrides,
      overrides = _props$overrides === void 0 ? {} : _props$overrides;

  var _getOverrides = (0, _overrides.getOverrides)(overrides.SelectComponentIcon, _styledComponents.SelectComponentIcon),
      _getOverrides2 = _slicedToArray(_getOverrides, 2),
      SelectComponentIcon = _getOverrides2[0],
      selectComponentIconProps = _getOverrides2[1];

  var _getOverrides3 = (0, _overrides.getOverrides)(overrides.DropDown, _styledComponents.DropDown),
      _getOverrides4 = _slicedToArray(_getOverrides3, 2),
      DropDown = _getOverrides4[0],
      dropDownProps = _getOverrides4[1];

  var _getOverrides5 = (0, _overrides.getOverrides)(overrides.DropDownItem, _styledComponents.DropDownItem),
      _getOverrides6 = _slicedToArray(_getOverrides5, 2),
      DropDownItem = _getOverrides6[0],
      dropDownItemProps = _getOverrides6[1];

  var _getOverrides7 = (0, _overrides.getOverrides)(overrides.Option, _styledComponents.Option),
      _getOverrides8 = _slicedToArray(_getOverrides7, 2),
      Option = _getOverrides8[0],
      optionProps = _getOverrides8[1];

  var _getOverrides9 = (0, _overrides.getOverrides)(overrides.SelectSpinner, _styledComponents.SelectSpinner),
      _getOverrides10 = _slicedToArray(_getOverrides9, 2),
      SelectSpinner = _getOverrides10[0],
      selectSpinnerProps = _getOverrides10[1];

  var _props$options = props.options,
      options = _props$options === void 0 ? [] : _props$options,
      getOptionLabel = props.getOptionLabel,
      isDropDownOpen = props.isDropDownOpen,
      optionsLoaded = props.optionsLoaded,
      selectedOptions = props.selectedOptions,
      onChange = props.onChange,
      onItemSelect = props.onItemSelect,
      type = props.type,
      maxDropdownHeight = props.maxDropdownHeight,
      multiple = props.multiple;
  return isDropDownOpen ? React.createElement(_menu.StatefulMenu, {
    getRequiredItemProps: function getRequiredItemProps(option, index) {
      return option.disabled ? {
        onClickCapture: function onClickCapture(e) {
          return e.stopPropagation();
        }
      } : {
        onClick: function onClick(e) {
          return onChange(e, option);
        }
      };
    },
    overrides: {
      List: {
        component: DropDown,
        style: {
          maxHeight: maxDropdownHeight
        },
        props: _objectSpread({
          role: 'listbox',
          'aria-multiselectable': multiple,
          $type: type,
          $isOpen: isDropDownOpen
        }, dropDownProps)
      },
      Option: {
        props: {
          overrides: {
            ListItem: {
              component: DropDownItem,
              props: dropDownItemProps
            }
          },

          /* eslint-disable-next-line react/display-name*/
          getItemLabel: function getItemLabel(option) {
            var $selected = selectedOptions.find(function (selected) {
              return selected.id === option.id;
            });
            return optionsLoaded ? React.createElement(Option, _extends({
              "aria-readonly": option.disabled,
              "aria-selected": !!$selected,
              disabled: option.disabled,
              $selected: $selected,
              key: option.id
            }, optionProps), $selected && React.createElement(SelectComponentIcon, _extends({
              $type: _constants.ICON.selected,
              src: 'data:image/svg+xml;utf8,<svg width="10" height="9" viewBox="0 0 11 10" fill="none" xmlns="http://www.w3.org/2000/svg"><path d="M1 6L4 9L10 1" stroke="#1B6DE0" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"/></svg>'
            }, selectComponentIconProps)), getOptionLabel(option)) : React.createElement(SelectSpinner, selectSpinnerProps, React.createElement(_spinner.Spinner, {
              size: 22
            }));
          }
        }
      }
    },
    onItemSelect: onItemSelect,
    items: optionsLoaded ? options : [{}]
  }) : React.createElement("div", null);
}