"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _reactDom = require("react-dom");

var _styledComponents = require("./styled-components");

var _input = require("../input");

var _tag = require("../tag");

var _constants = require("./constants");

var _dropdown = _interopRequireDefault(require("./dropdown"));

var _overrides = require("../helpers/overrides");

var _constants2 = require("../menu/constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Select =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Select, _React$Component);

  function Select(props) {
    var _this;

    _classCallCheck(this, Select);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Select).call(this, props));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
      filteredOptions: null,
      textValue: '',
      isDropDownOpen: false,
      options: [],
      optionsLoaded: false
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleClickEvent", function (event) {
      // eslint-disable-next-line react/no-find-dom-node
      var el = (0, _reactDom.findDOMNode)(_assertThisInitialized(_assertThisInitialized(_this)));
      /* eslint-disable-next-line flowtype/no-weak-types */

      if (el && !el.contains(event.target)) {
        _this.setState({
          isDropDownOpen: false
        });
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onTextInputChange", function (e) {
      // $FlowFixMe
      var newTextValue = e.target.value;

      _this.setState({
        textValue: newTextValue
      });

      _this.props.onTextInputChange(e);

      _this.openDropDown(newTextValue, function () {
        if (_this.props.filterable) {
          var filteredOptions = _this.state.options.filter(function (option) {
            return _this.filterOption(option, newTextValue);
          }); // reset filtered options for new search


          if (!filteredOptions.length) {
            filteredOptions = newTextValue ? [] : null;
          }

          _this.setState({
            filteredOptions: filteredOptions
          });
        }
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onClearAll", function (event) {
      _this.props.onChange({
        event: event,
        type: _constants.STATE_CHANGE_TYPE.unselect,
        selectedOptions: []
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onSelect", function (event) {
      var pendingOption = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {
        id: '',
        label: ''
      };
      var _this$props = _this.props,
          multiple = _this$props.multiple,
          selectedOptions = _this$props.selectedOptions;
      var selected = selectedOptions.find(function (tag) {
        return tag.id === pendingOption.id;
      });
      var isSelect = !selected;

      if (isSelect) {
        // select
        _this.props.onChange({
          event: event,
          type: _constants.STATE_CHANGE_TYPE.select,
          option: pendingOption,
          selectedOptions: multiple ? selectedOptions.concat([pendingOption]) : [pendingOption]
        });
      } else if (multiple) {
        // unselect (only possible for multi-select)
        _this.props.onChange({
          event: event,
          type: _constants.STATE_CHANGE_TYPE.unselect,
          option: pendingOption,
          selectedOptions: selectedOptions.filter(function (selectedOption) {
            return selectedOption.id !== (selected || {}).id;
          })
        });
      } // Always close single-select dropdown after toggling selection


      if (_this.props.type === _constants.TYPE.select && !multiple) {
        _this.setState({
          isDropDownOpen: false
        });
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onRemoveTag", function (event, option) {
      _this.props.onChange({
        event: event,
        type: _constants.STATE_CHANGE_TYPE.unselect,
        option: option,
        selectedOptions: _this.props.selectedOptions.filter(function (selectedOption) {
          return selectedOption.id !== option.id;
        })
      });
    });

    return _this;
  }

  _createClass(Select, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (typeof document !== 'undefined') {
        document.addEventListener('click', this.handleClickEvent, {
          capture: true
        });
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (typeof document !== 'undefined') {
        document.removeEventListener('click', this.handleClickEvent, {
          capture: true
        });
      }
    }
  }, {
    key: "loadOptions",
    value: function loadOptions(query) {
      var _this2 = this;

      return new Promise(function (resolve) {
        var options = _this2.props.options;

        _this2.setState({
          optionsLoaded: false
        });

        if (typeof options === 'function') {
          options(query).then(function (loadedOptions) {
            _this2.setState({
              options: loadedOptions,
              optionsLoaded: true
            }, resolve);
          });
        } else {
          _this2.setState({
            options: options,
            optionsLoaded: true
          }, resolve);
        }
      });
    }
  }, {
    key: "getOptions",
    value: function getOptions() {
      return this.state.filteredOptions || this.state.options || [];
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props$overrides = this.props.overrides,
          overrides = _this$props$overrides === void 0 ? {} : _this$props$overrides;

      var _getOverrides = (0, _overrides.getOverrides)(overrides.Root, _styledComponents.Root),
          _getOverrides2 = _slicedToArray(_getOverrides, 2),
          Root = _getOverrides2[0],
          rootProps = _getOverrides2[1];

      return React.createElement(Root, rootProps, this.props.type === _constants.TYPE.search ? this.getSearch() : this.getSelect(), this.getDropDown());
    }
  }, {
    key: "getSelect",
    value: function getSelect() {
      var _this3 = this;

      var _this$getSubComponent = this.getSubComponents(),
          _this$getSubComponent2 = _slicedToArray(_this$getSubComponent.Root, 2),
          Root = _this$getSubComponent2[0],
          rootProps = _this$getSubComponent2[1],
          _this$getSubComponent3 = _slicedToArray(_this$getSubComponent.Input, 2),
          Input = _this$getSubComponent3[0],
          inputProps = _this$getSubComponent3[1],
          _this$getSubComponent4 = _slicedToArray(_this$getSubComponent.SelectComponentIcon, 2),
          SelectComponentIcon = _this$getSubComponent4[0],
          selectComponentIconProps = _this$getSubComponent4[1],
          _this$getSubComponent5 = _slicedToArray(_this$getSubComponent.InputContainer, 2),
          InputContainer = _this$getSubComponent5[0],
          inputContainerProps = _this$getSubComponent5[1];

      var _this$props2 = this.props,
          placeholder = _this$props2.placeholder,
          disabled = _this$props2.disabled,
          selectedOptions = _this$props2.selectedOptions;
      var events = disabled ? {
        onClickCapture: function onClickCapture(e) {
          return e.stopPropagation();
        }
      } : {
        onKeyDown: function onKeyDown(e) {
          return _this3.handledHotKeys(e);
        },
        onClick: function onClick() {
          var newValue = !_this3.state.isDropDownOpen;
          newValue ? _this3.openDropDown() : _this3.setState({
            isDropDownOpen: newValue
          });
        }
      };
      return React.createElement("div", _extends({
        tabIndex: this.props.tabIndex
      }, events), React.createElement(_input.Input, {
        disabled: true,
        placeholder: !selectedOptions.length ? placeholder : '',
        overrides: {
          Root: {
            component: Root,
            props: rootProps
          },
          Input: {
            component: Input,
            props: _objectSpread({}, this.getAccessibilityProps(), inputProps)
          },
          InputContainer: {
            component: InputContainer,
            props: inputContainerProps
          },
          After: function After() {
            return React.createElement(SelectComponentIcon, _extends({
              $type: _constants.ICON.select,
              src: 'data:image/svg+xml;utf8,<svg width="12" height="6" viewBox="0 0 12 6" fill="none" xmlns="http://www.w3.org/2000/svg"><path d="M5.29289 5.29289L0.853553 0.853553C0.538571 0.538571 0.761654 0 1.20711 0H10.7929C11.2383 0 11.4614 0.538571 11.1464 0.853554L6.70711 5.29289C6.31658 5.68342 5.68342 5.68342 5.29289 5.29289Z" transform="translate(12) scale(-1 1)" fill="#666666"/></svg>'
            }, selectComponentIconProps));
          },
          Before: function Before() {
            return _this3.getMultipleSelections();
          }
        }
      }));
    }
  }, {
    key: "getSearch",
    value: function getSearch() {
      var _this4 = this;

      var _this$getSubComponent6 = this.getSubComponents(),
          _this$getSubComponent7 = _slicedToArray(_this$getSubComponent6.InputContainer, 2),
          InputContainer = _this$getSubComponent7[0],
          inputContainerProps = _this$getSubComponent7[1],
          _this$getSubComponent8 = _slicedToArray(_this$getSubComponent6.Input, 2),
          Input = _this$getSubComponent8[0],
          inputProps = _this$getSubComponent8[1],
          _this$getSubComponent9 = _slicedToArray(_this$getSubComponent6.SelectComponentIcon, 2),
          SelectComponentIcon = _this$getSubComponent9[0],
          selectComponentIconProps = _this$getSubComponent9[1];

      var _this$props3 = this.props,
          placeholder = _this$props3.placeholder,
          error = _this$props3.error,
          disabled = _this$props3.disabled;
      var textValue = this.state.textValue;
      return React.createElement(_input.Input, {
        error: !!error,
        placeholder: placeholder,
        value: textValue //$FlowFixMe
        ,
        onChange: this.onTextInputChange,
        overrides: {
          Input: {
            props: _objectSpread({}, this.getAccessibilityProps(), {
              tabIndex: this.props.tabIndex,
              // onKeyDown happens before onChange to avoid race condition in set of value and hot keys processing
              onKeyDown: function onKeyDown(e) {
                return _this4.handledHotKeys(e);
              }
            }, inputProps),
            component: Input
          },
          InputContainer: {
            component: InputContainer,
            props: inputContainerProps
          },
          After: function After() {
            return React.createElement(SelectComponentIcon, _extends({
              $disabled: disabled,
              onClick: _this4.onClearAll,
              $type: _constants.ICON.clearAll,
              src: 'data:image/svg+xml;utf8,<svg width="16" height="16" viewBox="0 0 16 16" fill="none" xmlns="http://www.w3.org/2000/svg"><path fill-rule="evenodd" clip-rule="evenodd" d="M8 16C12.4183 16 16 12.4183 16 8C16 3.58173 12.4183 0 8 0C3.58173 0 0 3.58173 0 8C0 12.4183 3.58173 16 8 16ZM6.03033 4.96967C5.73743 4.67679 5.26257 4.67679 4.96967 4.96967C4.67676 5.26257 4.67676 5.73743 4.96967 6.03033L6.93933 8L4.96967 9.96967C4.67676 10.2626 4.67676 10.7374 4.96967 11.0303C5.26257 11.3232 5.73743 11.3232 6.03033 11.0303L8 9.06067L9.96967 11.0303C10.2626 11.3232 10.7374 11.3232 11.0303 11.0303C11.3232 10.7374 11.3232 10.2626 11.0303 9.96967L9.06067 8L11.0303 6.03033C11.3232 5.73743 11.3232 5.26257 11.0303 4.96967C10.7374 4.67679 10.2626 4.67679 9.96967 4.96967L8 6.93933L6.03033 4.96967Z" fill="#999999"/></svg>'
            }, selectComponentIconProps));
          },
          Before: function Before() {
            return _this4.getMultipleSelections();
          }
        }
      });
    }
  }, {
    key: "getMultipleSelections",
    value: function getMultipleSelections() {
      var _this5 = this;

      var _this$getSubComponent10 = this.getSubComponents(),
          _this$getSubComponent11 = _slicedToArray(_this$getSubComponent10.SelectComponentIcon, 2),
          SelectComponentIcon = _this$getSubComponent11[0],
          selectComponentIconProps = _this$getSubComponent11[1],
          _this$getSubComponent12 = _slicedToArray(_this$getSubComponent10.Tag, 2),
          Tag = _this$getSubComponent12[0],
          tagProps = _this$getSubComponent12[1],
          _this$getSubComponent13 = _slicedToArray(_this$getSubComponent10.SingleSelection, 2),
          SingleSelection = _this$getSubComponent13[0],
          singleSelectionProps = _this$getSubComponent13[1],
          _this$getSubComponent14 = _slicedToArray(_this$getSubComponent10.SelectionContainer, 2),
          SelectionContainer = _this$getSubComponent14[0],
          selectionContainerProps = _this$getSubComponent14[1];

      var _this$props4 = this.props,
          type = _this$props4.type,
          disabled = _this$props4.disabled,
          selectedOptions = _this$props4.selectedOptions;
      var multiple = this.isMultiple();
      return React.createElement(SelectionContainer, _extends({
        role: "list"
      }, selectionContainerProps), type === _constants.TYPE.search && React.createElement(SelectComponentIcon, _extends({
        $type: _constants.ICON.loop,
        src: 'data:image/svg+xml;utf8,<svg width="15" height="15" viewBox="0 0 15 15" fill="none" xmlns="http://www.w3.org/2000/svg"><path d="M9 9L13 13M10 5C10 7.76142 7.76142 10 5 10C2.23858 10 0 7.76142 0 5C0 2.23858 2.23858 0 5 0C7.76142 0 10 2.23858 10 5Z" transform="translate(1 1)" stroke="#1B6DE0" stroke-width="2" stroke-linecap="round"/></svg>'
      }, selectComponentIconProps)), selectedOptions.map(function (option) {
        return multiple ? React.createElement(Tag, _extends({
          overrides: {
            Root: {
              props: {
                role: 'listitem'
              }
            }
          },
          disabled: disabled,
          key: option.id,
          onActionClick: function onActionClick(e) {
            _this5.onRemoveTag(e, option);

            e.stopPropagation();
          }
        }, tagProps), _this5.getSelectedOptionLabel(option)) : React.createElement(SingleSelection, _extends({
          role: "listitem",
          key: option.id,
          $disabled: disabled
        }, singleSelectionProps), _this5.getSelectedOptionLabel(option));
      }));
    }
  }, {
    key: "getDropDown",
    value: function getDropDown() {
      var _this6 = this;

      var _this$props5 = this.props,
          overrides = _this$props5.overrides,
          type = _this$props5.type,
          selectedOptions = _this$props5.selectedOptions;
      var maxDropdownHeight = this.props.maxDropdownHeight;

      if (typeof document !== 'undefined' && maxDropdownHeight.slice(-2) === 'px' && parseInt(maxDropdownHeight) > window.innerHeight) {
        // only for pixel-sized maxDropdownHeight
        maxDropdownHeight = '90vh';
      }

      var options = this.getOptions();
      var _this$state = this.state,
          isDropDownOpen = _this$state.isDropDownOpen,
          optionsLoaded = _this$state.optionsLoaded;
      var dropDownProps = {
        type: type,
        maxDropdownHeight: maxDropdownHeight,
        options: options,
        overrides: overrides,
        multiple: this.isMultiple(),
        optionsLoaded: optionsLoaded,
        isDropDownOpen: isDropDownOpen,
        selectedOptions: selectedOptions,
        getOptionLabel: this.getOptionLabel.bind(this),
        onItemSelect: function onItemSelect(_ref) {
          var item = _ref.item,
              event = _ref.event;
          return _this6.handledHotKeys(event, item);
        },
        onChange: this.onSelect.bind(this)
      };
      return React.createElement(_dropdown.default, dropDownProps);
    }
  }, {
    key: "getOptionLabel",
    value: function getOptionLabel(option) {
      var getOptionLabel = this.props.getOptionLabel;
      return getOptionLabel ? getOptionLabel(option) : option.label;
    }
  }, {
    key: "getSelectedOptionLabel",
    value: function getSelectedOptionLabel(option) {
      var getSelectedOptionLabel = this.props.getSelectedOptionLabel;
      return getSelectedOptionLabel ? getSelectedOptionLabel(option) : this.getOptionLabel(option);
    }
  }, {
    key: "filterOption",
    value: function filterOption(option, query) {
      if (this.props.filterOption) {
        return this.props.filterOption(option, query);
      }

      var label = this.getOptionLabel(option);
      return typeof label === 'string' && label.toLowerCase().includes(query.toLowerCase());
    }
  }, {
    key: "isMultiple",
    value: function isMultiple() {
      var _this$props6 = this.props,
          type = _this$props6.type,
          multiple = _this$props6.multiple;
      return type === _constants.TYPE.search ? true : multiple;
    }
  }, {
    key: "openDropDown",
    value: function openDropDown(newTextValue, callback) {
      var _this7 = this;

      this.setState({
        isDropDownOpen: true
      }, function () {
        _this7.loadOptions(newTextValue).then(callback);
      });
    }
  }, {
    key: "handledHotKeys",
    value: function handledHotKeys(e, option) {
      if (!e || !e.key) {
        return;
      }

      switch (e.key) {
        case _constants2.KEY_STRINGS.ArrowDown:
        case _constants2.KEY_STRINGS.Space:
          if (e.key === _constants2.KEY_STRINGS.Space && this.props.type === _constants.TYPE.search) {
            return;
          }

          if (!this.state.isDropDownOpen) {
            this.openDropDown();
            e.preventDefault();
            e.stopPropagation();
            return true;
          }

          return;

        case _constants2.KEY_STRINGS.Escape:
          this.setState({
            isDropDownOpen: false
          });
          return true;

        case _constants2.KEY_STRINGS.Enter:
          if (option) {
            this.onSelect(e, option);
          }

          return;

        case _constants2.KEY_STRINGS.Backspace:
          if (this.isMultiple() && !this.state.textValue) {
            var selectedOptions = this.props.selectedOptions;

            if (selectedOptions.length) {
              this.onRemoveTag(e, selectedOptions[selectedOptions.length - 1]);
            }

            return true;
          }

          return;
      }
    }
  }, {
    key: "getSubComponents",
    value: function getSubComponents() {
      var _this$props$overrides2 = this.props.overrides,
          overrides = _this$props$overrides2 === void 0 ? {} : _this$props$overrides2;
      return {
        Input: (0, _overrides.getOverrides)(overrides.Input, _styledComponents.Input),
        Tag: (0, _overrides.getOverrides)(overrides.Tag, _tag.Tag),
        Root: (0, _overrides.getOverrides)(overrides.Root, _styledComponents.Root),
        SelectionContainer: (0, _overrides.getOverrides)(overrides.SelectionContainer, _styledComponents.SelectionContainer),
        SelectComponentIcon: (0, _overrides.getOverrides)(overrides.SelectComponentIcon, _styledComponents.SelectComponentIcon),
        SingleSelection: (0, _overrides.getOverrides)(overrides.SingleSelection, _styledComponents.SingleSelection),
        InputContainer: (0, _overrides.getOverrides)(overrides.InputContainer, _styledComponents.InputContainer)
      };
    }
  }, {
    key: "getAccessibilityProps",
    value: function getAccessibilityProps() {
      var type = this.props.type;
      var isDropDownOpen = this.state.isDropDownOpen;
      return {
        role: 'combobox',
        'aria-autocomplete': type === _constants.TYPE.search ? 'list' : 'none',
        'aria-expanded': isDropDownOpen
      };
    }
  }]);

  return Select;
}(React.Component);

_defineProperty(Select, "defaultProps", {
  overrides: {},
  selectedOptions: [],
  options: [],
  onTextInputChange: function onTextInputChange() {},
  onChange: function onChange() {},
  onBlur: function onBlur() {},
  onFocus: function onFocus() {},
  onMouseEnter: function onMouseEnter() {},
  onMouseLeave: function onMouseLeave() {},
  onMouseDown: function onMouseDown() {},
  onMouseUp: function onMouseUp() {},
  error: false,
  autoFocus: false,
  filterable: false,
  multiple: false,
  maxDropdownHeight: '900px',
  tabIndex: 0,
  textValue: '',
  type: _constants.TYPE.select
});

var _default = Select;
exports.default = _default;