"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.tests = exports.suite = void 0;

var React = _interopRequireWildcard(require("react"));

var _styles = require("../styles");

var _index = require("./index");

var _tests$SIMPLE_EXAMPLE;

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var suite = 'Spinner Test Suite';
exports.suite = suite;
var tests = {
  SIMPLE_EXAMPLE: 'Spinner component',
  STYLE_PROPS_OVERRIDES: 'Spinner style and props overrides'
};
exports.tests = tests;
var Centered = (0, _styles.styled)('div', {
  position: 'relative',
  display: 'flex',
  flexDirection: 'row',
  justifyContent: 'center',
  alignItems: 'center',
  height: '90vh',
  lineHeight: 1.5
});
var Spacing = (0, _styles.styled)('span', {
  margin: '10px'
});

var _default = (_tests$SIMPLE_EXAMPLE = {}, _defineProperty(_tests$SIMPLE_EXAMPLE, tests.SIMPLE_EXAMPLE, function Story1() {
  return React.createElement(Centered, null, React.createElement(Spacing, null, React.createElement(_index.Spinner, {
    size: 22
  })), React.createElement(Spacing, null, React.createElement(_index.Spinner, null)), React.createElement(Spacing, null, React.createElement(_index.Spinner, {
    size: 88
  })));
}), _defineProperty(_tests$SIMPLE_EXAMPLE, tests.STYLE_PROPS_OVERRIDES, function Story3() {
  return React.createElement(Centered, null, React.createElement(_index.Spinner, {
    overrides: {
      Svg: {
        props: {
          'data-label': 'data-label'
        },
        style: function style(_ref) {
          var $theme = _ref.$theme;
          return {
            borderRadius: '50%',
            backgroundColor: $theme.colors.primary50
          };
        }
      }
    }
  }));
}), _tests$SIMPLE_EXAMPLE);

exports.default = _default;