"use strict";

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _index = require("../index");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
Copyright (c) 2018 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
describe('Component styled components', function () {
  test('StyledBody - basic render', function () {
    var component = (0, _enzyme.shallow)(_react.default.createElement(_index.StyledBody, null));
    expect(component.instance().getStyles()).toMatchSnapshot('StyledBody has correct default styles');
    component.setProps({
      $kind: _index.KIND.info
    });
    expect(component.instance().getStyles().backgroundColor).toEqual('$theme.colors.primary500');
    component.setProps({
      $kind: _index.KIND.positive
    });
    expect(component.instance().getStyles().backgroundColor).toEqual('$theme.colors.positive500');
    component.setProps({
      $kind: _index.KIND.warning
    });
    expect(component.instance().getStyles().backgroundColor).toEqual('$theme.colors.warning500');
    component.setProps({
      $kind: _index.KIND.negative
    });
    expect(component.instance().getStyles().backgroundColor).toEqual('$theme.colors.negative500');
    component.setProps({
      $isHidden: false,
      $isAnimating: false
    });
    expect(component.instance().getStyles().height).toEqual('auto');
    expect(component.instance().getStyles().opacity).toEqual(1);
    component.setProps({
      $isHidden: true,
      $isAnimating: true
    });
    expect(component.instance().getStyles().height).toEqual('auto');
    expect(component.instance().getStyles().opacity).toEqual(0);
    component.setProps({
      $isHidden: true,
      $isAnimating: false
    });
    expect(component.instance().getStyles().height).toEqual(0);
    expect(component.instance().getStyles().opacity).toEqual(0);
  });
  test('StyledCloseIcon - basic render', function () {
    var component = (0, _enzyme.shallow)(_react.default.createElement(_index.StyledCloseIcon, {
      $prop: false
    }));
    expect(component.instance().getStyles()).toMatchSnapshot('StyledSvg has correct default styles');
  });
});